前往小程序,Get更优阅读体验!
立即前往
首页
学习
活动
专区
工具
TVP
发布
社区首页 >专栏 >leetcode-441-Arranging Coins

leetcode-441-Arranging Coins

作者头像
chenjx85
发布2018-05-22 16:23:13
3470
发布2018-05-22 16:23:13
举报

题目描述:

You have a total of n coins that you want to form in a staircase shape, where every k-th row must have exactly k coins.

Given n, find the total number of full staircase rows that can be formed.

n is a non-negative integer and fits within the range of a 32-bit signed integer.

Example 1:

代码语言:javascript
复制
n = 5

The coins can form the following rows:
¤
¤ ¤
¤ ¤

Because the 3rd row is incomplete, we return 2.

Example 2:

代码语言:javascript
复制
n = 8

The coins can form the following rows:
¤
¤ ¤
¤ ¤ ¤
¤ ¤

Because the 4th row is incomplete, we return 3.

要完成的函数:

int arrangeCoins(int n) 

说明:

1、这道题目看起来很容易,换成人类来思考的话,就是利用等差数列的和来做,满足t(t+1)<=2n<(t+1)(t+2),然后返回t。

我们对上面式子做个变形,要由n求出t值,很容易的。

t(t+1)<=2n

t^2+t<=2n

t^2+t+1/4<=2n+1/4

(t+1/2)^2<=2n+1/4

t<=sqrt(2n+1/4)-1/2

t是最靠近的那个整数,所以取下地板函数floor()

代码如下:

代码语言:javascript
复制
    int arrangeCoins(int n) 
    {
        return floor(sqrt((double)2*n+0.25)-0.5);
    }

上述代码实测41ms,排名很靠后。

2、改进:

上述代码浪费时间的地方在于sqrt函数,sqrt内部实现应该是泰勒展开,比较耗时间。

如果我们把泰勒公式换成二分查找,应该会更快,几趟迭代就能够找到我们要的值。

改进完实测33ms,beats 78.81% of cpp submissions。

二分查找很熟悉啦,而且前面做过差不多的题目,就不再贴出来了。

具体可以参考leetcode网站:https://leetcode.com/problems/arranging-coins/discuss/92314/C++-Three-solutions:-O(n)-O(logn)-O(1)

本文参与 腾讯云自媒体分享计划,分享自作者个人站点/博客。
原始发表:2018-04-22 ,如有侵权请联系 cloudcommunity@tencent.com 删除

本文分享自 作者个人站点/博客 前往查看

如有侵权,请联系 cloudcommunity@tencent.com 删除。

本文参与 腾讯云自媒体分享计划  ,欢迎热爱写作的你一起参与!

评论
登录后参与评论
0 条评论
热度
最新
推荐阅读
目录
  • 题目描述:
  • 要完成的函数:
  • 说明:
领券
问题归档专栏文章快讯文章归档关键词归档开发者手册归档开发者手册 Section 归档